
import sdljava.SDLException;
import sdljava.event.SDLEvent;
import sdljava.event.SDLEventType;
import sdljava.event.SDLKey;
import sdljava.event.SDLKeyboardEvent;
import sdljava.event.SDLMouseButtonEvent;



public class Keyboard {

	private sdljava.event.SDLEvent event;
	private sdljava.event.SDLKeyboardEvent keyboardevent;
	private int numkeys;
	private int keyreturn;
	private int keys;
	private int key[];
	
	public void initkeys(){
		
		numkeys = 8;
		key[1] = sdljava.event.SDLKey.SDLK_LEFT;
		
		
	}
	private int ascii2key (int ascii){
		
		int numberkey = 0;
		switch (ascii){
			
			case 27 : //tecla ESC , salimos del programa
				numberkey = -2;
				break;
		
			case 97: //a 
				numberkey = 0;
				break;
			case 115: //s
				numberkey = 1;
				break;			
			case 100: //d
				numberkey = 2;
				break;
			case 102: //f
				numberkey = 3;
				break;
			case 103: //g
				numberkey = 4;
				break;
			case 104:
				numberkey = 5;
				break;
			case 106:
				numberkey = 6;
				break;
			case 107:
				numberkey = 7;
				break;
			case 108:
				numberkey = 8;
				break;
			case 119: //w
				numberkey = 20; //numeros mayores que 20 = teclas negras
				break;
			case 101: //e
				numberkey = 21;
				break;
			case 116: //t
				numberkey = 23;
				break;
			case 121: //y
				numberkey = 24; //nos saltamos el 23 por no haber nota
				break;
			case 117: //u
				numberkey = 25;
				break;
			case 111: //o
				numberkey = 27;
				break;
			case 112: //p
				numberkey = 28; //nos saltamos el 27
				break;
				
				
			case 274: //abajo
				numberkey = 202;
				break;
			case 273: //arriba
				numberkey = 201;
				break;
			case 13: //enter
				numberkey = 200;
				break;
				
				
				
				
			default :
				numberkey = -1;
				break;
			
			
		}
		
		return numberkey;
		
	}
	
	public int readKeyboard() throws SDLException, InterruptedException {

		//sdljava.event.SDLEvent event=null;
		 sdljava.event.SDLKeyboardEvent keyb = null;
		 
		//event = SDLEvent.waitEvent();
		
		//keyboardevent.pollEvent();
		//System.out.println(keyboardevent.getType());
		
		//sdljava.event.SDLKeyboardEvent keyboardevent = null;
		 //keyboardevent = (SDLKeyboardEvent) keyboardevent.pollEvent();
		// event = event.waitEvent(true);
		this.event=event.pollEvent();
		 
		 
	   int posX;
	   int posY;
	    
	   int pushKey = -1;
	    if (event != null){
		   	if (event.getType() == SDLEventType.KEYDOWN){
		   		
		   		pushKey = ((SDLKeyboardEvent)event).getSym();
	   			//System.out.println(pushKey);
	   			//System.out.println((char)pushKey);

		   	}
		   	else{
		   		try{ //comprueba que es un evento de teclado y no uno de raton
			   		if ( (((SDLKeyboardEvent)event).getSym() ==303) ||
			   				(((SDLKeyboardEvent)event).getSym() ==304) ){
			   			pushKey = 303;
			   		}
		   		}
		   		catch (java.lang.ClassCastException error){
		   			
		   		}
		   		
		   	}
	   }
	   
	   return pushKey;
	}
	public boolean isClicked (CSprite sprite){
		boolean click = false;
		
		    
		   int posX;
		   int posY;
		    
		   int eventKey = 0;//1 para keydown, 2 para keyup
		   int pushKey = -1; //devuelve -1 en caso de que no se haya pulsado ninguna tecla 
		   SDLMouseButtonEvent eventMouse ;

		   
		   if (event != null){
			  switch(event.getType()){
			  
				  case SDLEventType.MOUSEBUTTONDOWN:
					  	
					  System.out.println("has pulsado el boton");
					  eventMouse = ((sdljava.event.SDLMouseButtonEvent)event);
					  
					  posX = eventMouse.getX();
					  posY = eventMouse.getY();

					  if ((posY > sprite.gety() )&&
						  (posY < sprite.gety()+sprite.geth())&&
						  (posX > sprite.getx() )&&
						  (posX < sprite.getx() + sprite.getw()) ){
						  
						  click = true;
					  }
			  }
		   }
	
		return click;	
		
	}
	
	public boolean isClicked (int x, int h, int y, int w){
		boolean click = false;
		
		    
		   int posX;
		   int posY;
		    
		   int eventKey = 0;//1 para keydown, 2 para keyup
		   int pushKey = -1; //devuelve -1 en caso de que no se haya pulsado ninguna tecla 
		   SDLMouseButtonEvent eventMouse ;

		   
		   if (event != null){
			  switch(event.getType()){
			  
				  case SDLEventType.MOUSEBUTTONDOWN:
					  	
					  System.out.println("has pulsado el boton");
					  eventMouse = ((sdljava.event.SDLMouseButtonEvent)event);
					  
					  posX = eventMouse.getX();
					  posY = eventMouse.getY();

					  if ((posY > y )&&
						  (posY < y+h)&&
						  (posX > x )&&
						  (posX < x + w) ){
						  
						  click = true;
					  }
			  }
		   }
	
		return click;	
		
	}
	
	public int keynumber() throws SDLException {

		//sdljava.event.SDLEvent event=null;
		 sdljava.event.SDLKeyboardEvent keyb = null;
		 
		//event = SDLEvent.waitEvent();
		
		//keyboardevent.pollEvent();
		//System.out.println(keyboardevent.getType());
		
		//sdljava.event.SDLKeyboardEvent keyboardevent = null;
		 //keyboardevent = (SDLKeyboardEvent) keyboardevent.pollEvent();
		 
	   event=event.pollEvent();
	    
	   int posX;
	   int posY;
	    
	   int eventKey = 0;//1 para keydown, 2 para keyup
	   int pushKey = -1; //devuelve -1 en caso de que no se haya pulsado ninguna tecla 
	   SDLMouseButtonEvent eventMouse ;
	   sdljava.event.SDLMouseMotionEvent moveMouse;
	   
	   if (event != null){
		  switch(event.getType()){
		  
		      case SDLEventType.MOUSEMOTION: //si movemos el raton, se quita la nota
			  
		    	  moveMouse = ((sdljava.event.SDLMouseMotionEvent)event);
		    	  posX = moveMouse.getX();
		    	  posY = moveMouse.getY();
		    	  
				  if (posY > 520){
					  
			    	  pushKey = (posX-20) / 50;
			    	  pushKey = pushKey + 100;
				  }

			  break;
		  
			  case SDLEventType.MOUSEBUTTONDOWN:
				  	
				  eventMouse = ((sdljava.event.SDLMouseButtonEvent)event);
				  
				  posX = eventMouse.getX();
				  posY = eventMouse.getY();
				  
				//  System.out.println(posX);
				//  System.out.println(posY);
				  
				  
				  if (posY > 520){
				  
					  pushKey = (posX-20) / 50;
				  }
				  
					break;
			  case SDLEventType.KEYDOWN:
				  	eventKey = 1;
				  	break;
			  case SDLEventType.KEYUP:
				  	eventKey = 2;
				  	break;
		  }
		  if ( (eventKey == 1) || (eventKey ==2 )) {
			  
				  pushKey = ((SDLKeyboardEvent)event).getSym();
				  
				 // System.out.println(((SDLKeyboardEvent)event).getSym());
				  pushKey = ascii2key(pushKey);
	
		      }
				  	
			if ((eventKey == 2) && (pushKey >= 0) ){
				pushKey = pushKey + 100;
			}
		
	   }
/*
		 while (sdljava.event.SDLKeyboardEvent.pollEvent() != null )  {	
		
			if (sdljava.event.SDLEventType.QUIT  == sdljava.event.SDLEvent.SDL_QUIT) { //event.type//comprobamos si se sale del programa
				
			}

		 }*/
		return pushKey; //devuelve -1 si no se ha pulsado ninguna tecla

	}
		
	public void waitrelease() throws SDLException{
		
		boolean end = false;
		sdljava.event.SDLEvent event=null;
		 sdljava.event.SDLKeyboardEvent keyb = null;
		 
		 event = SDLEvent.waitEvent();


		 
	}
	
	
}
