
import java.io.BufferedInputStream;

import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;

import java.io.FileOutputStream;

import java.io.FileWriter;
import java.io.IOException;

import java.io.PrintWriter;



public class Score {

	private int score ;
	private FileWriter write ;
	private PrintWriter text ;
	private int maxScore ; //numero máximo de puntuaciones por archivo
	
	private int notecombo;
	private int maxcombo;
	
	public int getmaxScore(){
		return maxScore;
	}
	public Score () {
		notecombo = 1;
		maxcombo = 1;
		score=0;
		maxScore = 5;
	}
	
	public int getScore () {
		return score;
		
	}
	
	public void setScore(int s){
		score = s;
	}

	public void addScore(String s){
		if (s == "good"){
			score = score + 5 *notecombo;
		}
		if (s == "perfect"){
			score = score + 10*notecombo;
		}
		
	}
	
	public void save(String song) throws IOException{
		
		boolean exists = (new File("filename")).exists();
		int minPos;
		
		minPos = 0;
		
		String name = (String) song.subSequence(0, song.length() - 4);

		exists = new File("score" + File.separator + name + ".txt").exists();

		if ( ! exists ){
			System.out.println("entra en no creado");
			 write = new FileWriter("score" + File.separator + name + ".txt");
			 text = new PrintWriter(write);
			 
			 text.println(String.valueOf(score));
			 
			 write.flush();
			 write.close();
			
		}
		else{
			minPos = this.getMinScore(song);
			System.out.println("minima posicion = " + minPos);
			
			if (minPos <= maxScore){ //no sobrepasa el límite
				insertScore(song, minPos);
			}
		}
	}
	public void saveUser(String song, String user) throws IOException{
		
		
		boolean exists = (new File("filename")).exists();
		int minPos;
		
		minPos = 0;
		
		if (user.isEmpty()){
			user = "Anonymous";
		}
		String name = (String) song.subSequence(0, song.length() - 4);

		exists = new File("score" + File.separator + name + ".txt").exists();

		if ( ! exists ){
			System.out.println("entra en no creado");
			 write = new FileWriter("score"+ File.separator + name + ".txt");
			 text = new PrintWriter(write);
			 
			 text.println(user);
			 text.println(String.valueOf(score));
			 
			 
			 write.flush();
			 write.close();
			
		}
		else{
			minPos = this.getMinUserScore(song);
			System.out.println("minima posicion = " + minPos);
			
			if (minPos <= maxScore){ //no sobrepasa el límite
				insertUserScore(song, minPos, user);
			}
		}
	}
	@SuppressWarnings("deprecation")
	public String[] readscore(String song) throws IOException{
		
		String name = (String) song.subSequence(0, song.length() - 4);
		
		//int score = 0;
		String [] score = new String [maxScore*2];
		 int numScore=0;
		boolean exists = (new File("score"+File.separator + name + ".txt").exists());
		
		if (exists){
			File file = new File("score"+ File.separator + name + ".txt");
		    FileInputStream fis = null;
		    BufferedInputStream bis = null;
		    DataInputStream dis = null;
		
		    fis = new FileInputStream(file);
	
		      // Here BufferedInputStream is added for fast reading.
		      bis = new BufferedInputStream(fis);
		      dis = new DataInputStream(bis);
		     
		      // dis.available() returns 0 if the file does not have more lines.
		      while ( (dis.available() != 0) && (numScore < maxScore*2) ){
		    	  
		      // this statement reads the line from the file and print it to
		        // the console.
		    	  score[numScore] = dis.readLine();
		    	  numScore ++;
		      }
		      fis.close();
		      bis.close();
		      dis.close();
		}
		
			for (int i=numScore;i<=(maxScore*2)-1;i++){
				score[i]="Empty";
			}
		return score;
		
	}

	@SuppressWarnings("deprecation")
	public int getMinScore(String song) throws IOException{ //devuelve la posicion
		
		String name = (String) song.subSequence(0, song.length() - 4);
		
		int numScore = 1;
		int minPos = 1;
		String actualScore = "";
		String minScore = "";
		
		File file = new File("score" + File.separator + name + ".txt");
	    FileInputStream fis = null;
	    BufferedInputStream bis = null;
	    DataInputStream dis = null;

	    fis = new FileInputStream(file);

	      // Here BufferedInputStream is added for fast reading.
	    bis = new BufferedInputStream(fis);
	      dis = new DataInputStream(bis);

	    minScore = dis.readLine(); //tomamos como menor el primer elemento
	    
	    // dis.available() returns 0 if the file does not have more lines.
	    while (dis.available() != 0) {
	    	  numScore ++;
	    	  actualScore = dis.readLine(); //segundo elemento
	    	  //System.out.println(numScore);
	    	  //System.out.println(actualScore);
	    	  //System.out.println(minScore);
	    	  if ((Integer.parseInt(actualScore))  <= (Integer.parseInt(minScore) ) ){
	    		// System.out.println("comparamos " + (Integer.parseInt(actualScore))  + " y "+ (Integer.parseInt(minScore) ));
	    		  	minPos = numScore ;
	    		  	minScore = actualScore;
	    	  }
	      // this statement reads the line from the file and print it to
	        // the console.
	        
	    }
	    if (numScore < maxScore){ //si hay menos puntuacion que maxScore
	    	 
	    	minPos = numScore+1; //insertamos al siguiente
	    	//System.out.println(minPos);
	    }
	    else {
	    	 System.out.println("lista llena");
		    	
	    	if (Integer.parseInt(minScore) >= score){ //el minimo es mayor que nuestra puntuación
	    		minPos = maxScore +1 ; //no se introduce
	    		 System.out.println("la puntuación es menor");
	    		
	    	}
	    }

	      fis.close();
	      bis.close();
	      dis.close();

	      return minPos;
		
	}
	
	@SuppressWarnings("deprecation")
	public int getMinUserScore(String song) throws IOException{ //devuelve la posicion
		
		String name = (String) song.subSequence(0, song.length() - 4);
		
		int numScore = 1;
		int minPos = 1;
		String actualScore = "";
		String minScore = "";
		
		File file = new File("score" + File.separator + name + ".txt");
	    FileInputStream fis = null;
	    BufferedInputStream bis = null;
	    DataInputStream dis = null;

	    fis = new FileInputStream(file);

	      // Here BufferedInputStream is added for fast reading.
	    bis = new BufferedInputStream(fis);
	      dis = new DataInputStream(bis);
	      
	      dis.readLine();
	    minScore = dis.readLine(); //tomamos como menor el primer elemento
	    
	    // dis.available() returns 0 if the file does not have more lines.
	    while (dis.available() != 0) {
	    	  numScore ++;
	    	  dis.readLine();
	    	  actualScore = dis.readLine(); //segundo elemento
	    	  //System.out.println(numScore);
	    	  //System.out.println(actualScore);
	    	  //System.out.println(minScore);
	    	  if ((Integer.parseInt(actualScore))  <= (Integer.parseInt(minScore) ) ){
	    		// System.out.println("comparamos " + (Integer.parseInt(actualScore))  + " y "+ (Integer.parseInt(minScore) ));
	    		  	minPos = numScore ;
	    		  	minScore = actualScore;
	    	  }
	      // this statement reads the line from the file and print it to
	        // the console.
	        
	    }
	    if (numScore < maxScore){ //si hay menos puntuacion que maxScore
	    	 
	    	minPos = numScore+1; //insertamos al siguiente
	    	//System.out.println(minPos);
	    }
	    else {
	    	 System.out.println("lista llena");
		    	
	    	if (Integer.parseInt(minScore) >= score){ //el minimo es mayor que nuestra puntuación
	    		minPos = maxScore +1 ; //no se introduce
	    		 System.out.println("la puntuación es menor");
	    		
	    	}
	    }

	      fis.close();
	      bis.close();
	      dis.close();

	      return minPos;
		
	}
	@SuppressWarnings("deprecation")
	public void insertScore(String song, int pos) throws IOException{
		
		String name = (String) song.subSequence(0, song.length() - 4);

	  // System.out.println(name);
	     
	     // input
		/*

		
	     FileInputStream fis  = new FileInputStream("score/" + name + ".txt");
	     BufferedInputStream in = new BufferedInputStream("score/" + name + ".txt");
		 */
	   File tempFile = new File("score" + File.separator + " temp.tmp");
	   File inFile = new File("score" + File.separator  + name + ".txt");
		
	    FileInputStream fis = null;
	    BufferedInputStream bis = null;
	    DataInputStream in = null;

	    fis = new FileInputStream(inFile);

	      // Here BufferedInputStream is added for fast reading.
	      bis = new BufferedInputStream(fis);
	      in = new DataInputStream(bis);
	      
	      
	     // output         
	     FileOutputStream fos = new FileOutputStream(tempFile);
	     PrintWriter out = new PrintWriter(fos);

	     String thisLine = "";
	     int i = 1;
	    
	     while ( ( in.available() != 0) && ( i <= maxScore) ) {
	    	
	    	// System.out.println("vamos por "+i+ " y tenemos que insertar en "+ pos );
			thisLine =  in.readLine();
		   if(i == pos){
			   out.println(score);
			   System.out.println("insertamos en i = " + i);
		   }
		   else{
			   out.println(thisLine);
		   }
		   i++;
	    }
	    if (i < maxScore){
	    	 out.println(score);
	    	
	    }
	    out.flush();
	    out.close();
	    in.close();

	    inFile.delete();
	    tempFile.renameTo( inFile);
	}
	public void insertUserScore(String song, int pos,String user) throws IOException{
		
		String name = (String) song.subSequence(0, song.length() - 4);


	  // System.out.println(name);
	     
	     // input
		/*

		
	     FileInputStream fis  = new FileInputStream("score/" + name + ".txt");
	     BufferedInputStream in = new BufferedInputStream("score/" + name + ".txt");
		 */
	   File tempFile = new File("score" + File.separator + "temp.tmp");
	   File inFile = new File("score" + File.separator  + name + ".txt");
		
	    FileInputStream fis = null;
	    BufferedInputStream bis = null;
	    DataInputStream in = null;

	    fis = new FileInputStream(inFile);

	      // Here BufferedInputStream is added for fast reading.
	      bis = new BufferedInputStream(fis);
	      in = new DataInputStream(bis);
	      
	      
	     // output         
	     FileOutputStream fos = new FileOutputStream(tempFile);
	     PrintWriter out = new PrintWriter(fos);

	     String scoreLine = "";
	     String userLine = "";
	     int i = 1;
	    
	     while ( ( in.available() != 0) && ( i <= maxScore) ) {
	    	
	    	// System.out.println("vamos por "+i+ " y tenemos que insertar en "+ pos );
			
			userLine =  in.readLine();
			scoreLine =  in.readLine();
		   if(i == pos){
			   out.println(user);
			   out.println(score);
			   
			   System.out.println("insertamos en i = " + i);
		   }
		   else{
			   out.println(userLine);
			   out.println(scoreLine);
			  
		   }
		   i++;
	    }
	    if (i < maxScore*2){
	    	
	    	out.println(user);
	    	 out.println(score);
	    	 
	    	
	    }
	    out.flush();
	    out.close();
	    in.close();

	    inFile.delete();
	    tempFile.renameTo( inFile);
	}
	public void resetnotecombo(){
		this.notecombo = 1;
		
	}
	public void incnotecombo(){
		this.notecombo++;
		
		this.maxcombo = Math.max(notecombo, maxcombo);
	}
	public void setNotecombo(int notecombo) {
		this.notecombo = notecombo;
	}
	public int getNotecombo() {
		return notecombo;
	}
	public void setMaxcombo(int maxcombo) {
		this.maxcombo = maxcombo;
	}
	public int getMaxcombo() {
		return maxcombo;
	}
}
